A portable, open-source, coherent noise-generating library for C++

Main Page | Modules | Class Hierarchy | Class List | File List | Class Members

# noise::module::Terrace Class Reference
[Modifier Modules]

`#include <terrace.h>`

Inheritance diagram for noise::module::Terrace:

List of all members.

## Detailed Description

Noise module that maps the output value from a source module onto a terrace-forming curve.

This noise module maps the output value from the source module onto a terrace-forming curve. The start of this curve has a slope of zero; its slope then smoothly increases. This curve also contains control points which resets the slope to zero at that point, producing a "terracing" effect. Refer to the following illustration:

To add a control point to this noise module, call the AddControlPoint() method.

An application must add a minimum of two control points to the curve. If this is not done, the GetValue() method fails. The control points can have any value, although no two control points can have the same value. There is no limit to the number of control points that can be added to the curve.

This noise module clamps the output value from the source module if that value is less than the value of the lowest control point or greater than the value of the highest control point.

This noise module is often used to generate terrain features such as your stereotypical desert canyon.

This noise module requires one source module.

## Public Member Functions

| Terrace ()
| Constructor.
| ~Terrace ()
| Destructor.
void | AddControlPoint (double value)
| Adds a control point to the terrace-forming curve.
void | ClearAllControlPoints ()
| Deletes all the control points on the terrace-forming curve.
const double * | GetControlPointArray () const
| Returns a pointer to the array of control points on the terrace-forming curve.
int | GetControlPointCount () const
| Returns the number of control points on the terrace-forming curve.
virtual int | GetSourceModuleCount () const
| Returns the number of source modules required by this noise module.
void | InvertTerraces (bool invert=true)
| Enables or disables the inversion of the terrace-forming curve between the control points.
bool | IsTerracesInverted () const
| Determines if the terrace-forming curve between the control points is inverted.
virtual double | GetValue (double x, double y, double z) const
| Generates an output value given the coordinates of the specified input value.
void | MakeControlPoints (int controlPointCount)
| Creates a number of equally-spaced control points that range from -1 to +1.

## Protected Member Functions

int | FindInsertionPos (double value)
| Determines the array index in which to insert the control point into the internal control point array.
void | InsertAtPos (int insertionPos, double value)
| Inserts the control point at the specified position in the internal control point array.

## Protected Attributes

int | m_controlPointCount
| Number of control points stored in this noise module.
bool | m_invertTerraces
| Determines if the terrace-forming curve between all control points is inverted.
double * | m_pControlPoints
| Array that stores the control points.

## Member Function Documentation

void Terrace::AddControlPoint | ( | double | value | ) |

Adds a control point to the terrace-forming curve.

Parameters:

  | value | The value of the control point to add.

Precondition:
  No two control points have the same value.

Exceptions:

  | noise::ExceptionInvalidParam | An invalid parameter was specified; see the preconditions for more information.

Two or more control points define the terrace-forming curve. The start of this curve has a slope of zero; its slope then smoothly increases. At the control points, its slope resets to zero.

It does not matter which order these points are added.

void Terrace::ClearAllControlPoints | ( |  | ) |

Deletes all the control points on the terrace-forming curve.

Postcondition:
  All control points on the terrace-forming curve are deleted.

int Terrace::FindInsertionPos | ( | double | value | ) | `[protected]`

Determines the array index in which to insert the control point into the internal control point array.

Parameters:

  | value | The value of the control point.

Returns:
  The array index in which to insert the control point.

Precondition:
  No two control points have the same value.

Exceptions:

  | noise::ExceptionInvalidParam | An invalid parameter was specified; see the preconditions for more information.

By inserting the control point at the returned array index, this class ensures that the control point array is sorted by value. The code that maps a value onto the curve requires a sorted control point array.

const double* noise::module::Terrace::GetControlPointArray | ( |  | ) | const`[inline]`

Returns a pointer to the array of control points on the terrace-forming curve.

Returns:
  A pointer to the array of control points in this noise module.

Two or more control points define the terrace-forming curve. The start of this curve has a slope of zero; its slope then smoothly increases. At the control points, its slope resets to zero.

Before calling this method, call GetControlPointCount() to determine the number of control points in this array.

It is recommended that an application does not store this pointer for later use since the pointer to the array may change if the application calls another method of this object.

int noise::module::Terrace::GetControlPointCount | ( |  | ) | const`[inline]`

Returns the number of control points on the terrace-forming curve.

Returns:
  The number of control points on the terrace-forming curve.

virtual int noise::module::Terrace::GetSourceModuleCount | ( |  | ) | const`[inline, virtual]`

Returns the number of source modules required by this noise module.

Returns:
  The number of source modules required by this noise module.

Implements noise::module::Module.

double Terrace::GetValue | ( | double | x,
|  | double | y,
|  | double | z
| ) | const`[virtual]`

Generates an output value given the coordinates of the specified input value.

Parameters:

  | x | The x coordinate of the input value.
  | y | The y coordinate of the input value.
  | z | The z coordinate of the input value.

Returns:
  The output value.

Precondition:
  All source modules required by this noise module have been passed to the SetSourceModule() method.

Before an application can call this method, it must first connect all required source modules via the SetSourceModule() method. If these source modules are not connected to this noise module, this method raises a debug assertion.

To determine the number of source modules required by this noise module, call the GetSourceModuleCount() method.

Implements noise::module::Module.

void Terrace::InsertAtPos | ( | int | insertionPos,
|  | double | value
| ) | `[protected]`

Inserts the control point at the specified position in the internal control point array.

Parameters:

  | insertionPos | The zero-based array position in which to insert the control point.
  | value | The value of the control point.

To make room for this new control point, this method reallocates the control point array and shifts all control points occurring after the insertion position up by one.

Because the curve mapping algorithm in this noise module requires that all control points in the array be sorted by value, the new control point should be inserted at the position in which the order is still preserved.

void noise::module::Terrace::InvertTerraces | ( | bool | invert = `true` | ) | `[inline]`

Enables or disables the inversion of the terrace-forming curve between the control points.

Parameters:

  | invert | Specifies whether to invert the curve between the control points.

bool noise::module::Terrace::IsTerracesInverted | ( |  | ) | const`[inline]`

Determines if the terrace-forming curve between the control points is inverted.

Returns:
  - true if the curve between the control points is inverted.
  - false if the curve between the control points is not inverted.

void Terrace::MakeControlPoints | ( | int | controlPointCount | ) |

Creates a number of equally-spaced control points that range from -1 to +1.

Parameters:

  | controlPointCount | The number of control points to generate.

Precondition:
  The number of control points must be greater than or equal to 2.

Postcondition:
  The previous control points on the terrace-forming curve are deleted.

Exceptions:

  | noise::ExceptionInvalidParam | An invalid parameter was specified; see the preconditions for more information.

Two or more control points define the terrace-forming curve. The start of this curve has a slope of zero; its slope then smoothly increases. At the control points, its slope resets to zero.

The documentation for this class was generated from the following files:

- terrace.h
- terrace.cpp